Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## echopointng.tree
Interface TreeModel

All Known Subinterfaces:
  TreeTableModel

All Known Implementing Classes:
  AbstractTreeTableModel, DefaultTreeModel, DefaultTreeTableModel

    public interface TreeModel

The `TreeModel` interface defines a suitable data model for a `Tree`.

There is an implied behavioural contract between a Tree and its TreeModel. The Tree gaurantees not to call any of the `getChildXXX()` methods until they are absolutely needed (for example a parent node is expanded).

This is to allow children to be lazily created "as needed". Ths is useful for very large TreeModels or ones where child node creation is an expensive operation

Note that the `isLeaf()` may be called at any time and if it returns true, then the node cannot contain any child nodes. However the inverse if not necessarily true. A model may return that a node is NOT a leaf but it may still have zero child nodes.

Method Summary
`void` | `addTreeModelListener(TreeModelListener l)` Adds a listener for the TreeModelEvent posted after the tree changes.
`java.lang.Object` | `getChild(java.lang.Object parent, int index)` Returns the child of parent at index index in the parent's child array.
`int` | `getChildCount(java.lang.Object parent)` Returns the number of children of parent.
`int` | `getIndexOfChild(java.lang.Object parent, java.lang.Object child)` Returns the index of child in parent.
`java.lang.Object` | `getRoot()` Returns the root of the tree.
`boolean` | `isLeaf(java.lang.Object node)` Returns true if node is a leaf.
`void` | `removeTreeModelListener(TreeModelListener l)` Removes a listener previously added with addTreeModelListener().
`void` | `valueForPathChanged(TreePath path, java.lang.Object newValue)` Messaged when the user has altered the value for the item identified by path to newValue.

Method Detail

### addTreeModelListener

    void addTreeModelListener(TreeModelListener l)

  Adds a listener for the TreeModelEvent posted after the tree changes.

  Parameters:
    `l` - the listener to add

### getChild

    java.lang.Object getChild(java.lang.Object parent,
                              int index)

  Returns the child of parent at index index in the parent's child array. parent must be a node previously obtained from this data source. This should not return null if index is a valid index for parent (that is index >= 0 && index < getChildCount(parent)).

  Parameters:
    `parent` - a node in the tree, obtained from this data source
  Returns:
    the child of parent at index index

### getChildCount

    int getChildCount(java.lang.Object parent)

  Returns the number of children of parent. Returns 0 if the node is a leaf or if it has no children. parent must be a node previously obtained from this data source.

  Parameters:
    `parent` - a node in the tree, obtained from this data source
  Returns:
    the number of children of the node parent

### getIndexOfChild

    int getIndexOfChild(java.lang.Object parent,
                        java.lang.Object child)

  Returns the index of child in parent.

### getRoot

    java.lang.Object getRoot()

  Returns the root of the tree. Returns null only if the tree has no nodes.

  Returns:
    the root of the tree

### isLeaf

    boolean isLeaf(java.lang.Object node)

  Returns true if node is a leaf. It is possible for this method to return false even if node has no children. A directory in a filesystem, for example, may contain no files; the node representing the directory is not a leaf, but it also has no children.

  Parameters:
    `node` - a node in the tree, obtained from this data source
  Returns:
    true if node is a leaf

### removeTreeModelListener

    void removeTreeModelListener(TreeModelListener l)

  Removes a listener previously added with addTreeModelListener().

### valueForPathChanged

    void valueForPathChanged(TreePath path,
                             java.lang.Object newValue)

  Messaged when the user has altered the value for the item identified by path to newValue. If newValue signifies a truly new value the model should post a treeNodesChanged event.

  Parameters:
    `path` - path to the node that the user has altered.
    `newValue` - the new value from the Tree.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD